import {
    Route,
    SessionAuthMiddleware,
    AuthRequiredMiddleware,
    scope,
    OAuth2Server,
    TokenAuthMiddleware
} from '@extollo/lib'
import {Home} from '../controllers/main/Home.controller'

Route.group('/', () => {
    Route.get('/')
        .calls<Home>(Home, home => home.welcome)
})

Route.group('', () => {
    Route.get('/dash')
        .pre(AuthRequiredMiddleware)
        .calls<Home>(Home, home => home.welcome)
}).pre(SessionAuthMiddleware)

OAuth2Server.routes()

Route.group('', () => {
    Route.get('tok')
        .pre(scope('tok'))
        .handledBy(() => 'Token!')
}).pre(TokenAuthMiddleware)

Route.socket('/ws/hello')
    .calls<Home>(Home, home => home.socket)
